<!DOCtYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="robots" content="noindex, nofollow">

    <title>Bridge Babelfish</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
    <link href="styles.css" rel="stylesheet">

    <script src="https://code.jquery.com/jquery-1.10.2.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/js/bootstrap.min.js"></script>
    <script src="socket.io/socket.io.js"></script>
</head>
<body>

    <div class="chat_window">
        <div class="top_menu">
            <div class="title">Bridge Babelfish</div>
        </div>
        <ul class="messages"></ul>
    </div>
    <script type="text/template" id="tlp">
        <li class="message">
            <div class="avatar"></div>
            <div class="text_wrapper">
                <div class="text-transcription"></div>
                <div class="text-traduction"></div>
            </div>
        </li>
    </script>

    <script type="text/javascript">
        var Message = function (arg) {
            this.transcription = arg.transcription;
            this.traduction = arg.traduction;
            this.utterance_id = arg.utterance_id || null;
            this.name = arg.name || '--';
            this.side = arg.side || 'left';
            this.draw = function (_this) {
                return function () {
                    var message = $($('#tlp').clone().html());
                    message.addClass(_this.side);
                    if(this.utterance_id != null){
                      message.attr("id", _this.utterance_id);
                      message.addClass("message-tt");
                    }
                    message.find('.text-transcription').html(_this.transcription);
                    message.find('.text-traduction').html(_this.traduction);
                    message.find('.avatar').html(_this.name);
                    $('.messages').append(message);
                    return setTimeout(function () {
                        return message.addClass('appeared');
                    }, 0);
                };
            }(this);
            return this;
        };

        var getMessageText, side, sendMessage;
        side = 'right';

        var updateMessage = function (ch, message_id, transcription, translation) {
            var elem = $("#" + message_id);
            elem.find(".text-transcription").text(transcription);;
            elem.find(".text-traduction").text(translation);
        }

        var sendMessage = function (ch, message_id, transcription, translation) {

            var messages, message;
            if (transcription.trim() === '') {
                return;
            }

            message = new Message({
                side: ch.side,
                name: ch.callerid_name,
                transcription: transcription,
                translation: translation,
                utterance_id: message_id
            });
            message.draw();

            messages = $('.messages');
            return messages.animate({ scrollTop: messages.prop('scrollHeight') }, 300);
        };

        var bridge = [];

        var getChannel = function(id){
          return bridge.find(function(ch){return ch.id === id})
        }

        var broadcast = function(data){
          // types of events:
          //  'new_bridge'
          //  'new_channel'
          //  'callerid_name'
          //  'transcription'
          //  'translation'
          //  'play_back'

          if(data.type === "new_bridge"){
            var ch1 = {
              id: data.uniqueid1,
              lang_from: "",
              lang_to: "",
              callerid_name: "",
              side: "left"
            }
            var ch2 = {
              id: data.uniqueid2,
              lang_from: "",
              lang_to: "",
              callerid_name: "",
              side: "right"
            }
            bridge = [ch1, ch2];

          }else if (data.type === "new_channel"){

            var ch = getChannel(data.uniqueid);

            ch.lang_from = data.from;
            ch.lang_to = data.to;
            ch.callerid_name = data.callerid_name;

            var msg = ch.callerid_name + " joined. (uniqueid='" + ch.id + "')";

            sendMessage(ch, "", msg, null);

          }else if(data.type === "transcription"){

            var ch = getChannel(data.uniqueid);
            var elem = $("#"+data.utterance_id);

            if (elem.length === 0){
              sendMessage(ch, data.utterance_id, data.transcription);
            }else{
              updateMessage(ch, data.utterance_id, data.transcription);
            }

          }else if(data.type === "translation"){

            var ch = getChannel(data.uniqueid);
            updateMessage(ch, data.utterance_id, data.transcription, data.translation);

          }
        };

        var socket = io();
        socket.on('broadcast', function(data){
          console.log(data);
          broadcast(data);
        });

        var simulation = function() {
          broadcast({
            type: "new_bridge",
            uniqueid1: "123",
            uniqueid2: "456"
          });
          broadcast({
            type: "new_channel",
            uniqueid: "123",
            from: "es-CO",
            to: "en-US",
            callerid_name: "Valen",
          });
          broadcast({
            type: "new_channel",
            uniqueid: "456",
            from: "en-US",
            to: "es-CO",
            callerid_name: "Diana",
          });
          broadcast({
            type: "transcription",
            uniqueid: "123",
            utterance_id: "13546684684684684",
            transcription: "Hola mundo",
          });

          setTimeout(function() {
            broadcast({
              type: "transcription",
              uniqueid: "123",
              utterance_id: "13546684684684684",
              transcription: "Hola mundo cruel",
            });
            setTimeout(function() {
              broadcast({
                type: "translation",
                uniqueid: "123",
                utterance_id: "13546684684684684",
                transcription: "Hola mundo cruel",
                translation: "Hello cruel world",
              });
            }, 1000);
          }, 1200);

          setTimeout(function() {
            broadcast({
              type: "transcription",
              uniqueid: "456",
              utterance_id: "asdfghjkl",
              transcription: "hi",
            });
            setTimeout(function() {
              broadcast({
                type: "transcription",
                uniqueid: "456",
                utterance_id: "asdfghjkl",
                transcription: "hi, how are",
              });
              setTimeout(function() {
                broadcast({
                  type: "transcription",
                  uniqueid: "456",
                  utterance_id: "asdfghjkl",
                  transcription: "hi, how are you?",
                });
                setTimeout(function() {
                  broadcast({
                    type: "translation",
                    uniqueid: "456",
                    utterance_id: "asdfghjkl",
                    transcription: "hi, how are you?",
                    translation: "hola, cómo estas?",
                  });
                }, 700);
              }, 500);
            }, 800);
          }, 1500);
        }
    </script>
</body>
</html>

